#pragma once

#define BPE_ERROR 65536
#define DEFAULTFRAMESIZE 4080
#define ENCODE 1
#define DECODE 2

typedef unsigned long ulong;
typedef unsigned short ushort;
typedef unsigned char uchar;

#pragma pack(push,1)

typedef struct {
	uchar sign[4];//"BPE2"
	ulong crc32;
	ushort maxframesize;
} BPEHEADR;

typedef struct {
	uchar pass;
	ushort decomp;
	ushort comp;
} FRAMEHEADR;


//ϊ
typedef struct {
	ushort twobyte;
	uchar onebyte;
} BPE_DIC;
#pragma pack(pop)



ulong frame_encode(uchar *data, ulong len, BPE_DIC *pdic, uchar *pass, ulong framesize);
ulong frame_decode(uchar *data, ulong len, BPE_DIC *pdic, uchar pass, ulong framesize);
ulong bpe_enc(uchar *infile, uchar *outfile, ulong framesize);
ulong bpe_dec(uchar *infile, uchar *outfile);

void crc32_starts(ulong *c32o);
void crc32_update(ulong *c32o, uchar *buf, ulong len);
void crc32_finish(ulong *c32o);

//BPEt@C
/*

[O[owb_]
"BPE2" (ulong)
crc32 (ulong)
őt[TCY(ushort)

[t[wb_]
pX(ushort)
̃TCY(ushort)
kTCY(ushort)
(pX * 3byte)

[kf[^]
oCi(kTCY)

ȉ[t[wb_][kf[^]...

*/
